commit 94f88926392ad8021092d5d557f073df4d6168d3
Author: freddy77 <freddy77>
Date:   Thu Jul 22 14:24:14 2010 +0000

    fix cursor2 issue

diff --git a/ChangeLog b/ChangeLog
index aa0f8cc..b3ea9ef 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Thu Jul 22 16:23:52 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c src/odbc/unittests/cursor2.c: fix cursor2 issue
+
 Thu Jul 22 16:11:23 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc_util.c:
 	- fix truncation problem setting an ascii string attribute (like
@@ -2732,4 +2735,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3086 2010/07/22 14:11:40 freddy77 Exp $
+$Id: ChangeLog,v 1.3087 2010/07/22 14:24:14 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 0e5469c..78c2773 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -61,7 +61,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.547 2010/07/18 06:45:23 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.548 2010/07/22 14:24:14 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version);
@@ -3190,12 +3190,14 @@ odbc_cursor_execute(TDS_STMT * stmt)
 	tds_set_state(tds, TDS_PENDING);
 	/* set cursor name for TDS7+ */
 	if (ret == TDS_SUCCEED && IS_TDS7_PLUS(tds) && !tds_dstr_isempty(&stmt->cursor_name)) {
-		ret = tds_process_simple_query(tds);
+		ret = odbc_process_tokens(stmt, TDS_RETURN_MSG|TDS_RETURN_DONE|TDS_STOPAT_ROW|TDS_STOPAT_COMPUTE);
 		stmt->row_count = tds->rows_affected;
 		stmt->dbc->current_statement = NULL;
-		if (ret == TDS_SUCCEED && cursor->cursor_id != 0) {
+		if (ret == TDS_CMD_DONE && cursor->cursor_id != 0) {
 			ret = tds_cursor_setname(tds, cursor);
 			tds_set_state(tds, TDS_PENDING);
+		} else {
+			ret = (ret == TDS_CMD_FAIL) ? TDS_FAIL : TDS_SUCCEED;
 		}
 		if (!cursor->cursor_id) {
 			stmt->cursor = NULL;
diff --git a/src/odbc/unittests/cursor2.c b/src/odbc/unittests/cursor2.c
index 141f352..954b833 100644
--- a/src/odbc/unittests/cursor2.c
+++ b/src/odbc/unittests/cursor2.c
@@ -5,7 +5,7 @@
  * 2) Test cursor returns results on language RPCs
  */
 
-static char software_version[] = "$Id: cursor2.c,v 1.10 2010/07/05 09:20:32 freddy77 Exp $";
+static char software_version[] = "$Id: cursor2.c,v 1.11 2010/07/22 14:24:14 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -15,11 +15,10 @@ main(int argc, char *argv[])
 	unsigned char msg[256];
 
 	odbc_connect();
+	odbc_check_cursor();
 
 	odbc_command("CREATE TABLE #cursor2_test (i INT)");
 
-	odbc_check_cursor();
-
 	odbc_reset_statement();
 	CHKSetStmtAttr(SQL_ATTR_CURSOR_TYPE, (SQLPOINTER) SQL_CURSOR_DYNAMIC, SQL_IS_INTEGER, "S");
 
@@ -30,7 +29,7 @@ main(int argc, char *argv[])
 
 
 	odbc_reset_statement();
-	odbc_command_with_result(odbc_stmt, "drop proc sp_test");
+	odbc_command_with_result(odbc_stmt, "if object_id('sp_test') is not null drop proc sp_test");
 	odbc_command("create proc sp_test @name varchar(30) as select 0 as pippo select 1 as 'test', @name as 'nome'");
 
 	odbc_reset_statement();

